import Blender
from Blender import Mathutils
from Blender.Mathutils import *
from Blender import Window

def my_callback(filename):                # callback for the FileSelector
    myfile = open(filename, 'w')

    myfile.write("---"+"\n")
    myfile.write("  name: track1"+"\n")
    myfile.write("  laps: 5"+"\n")
    myfile.write("  boxes:"+"\n")
    for o in objects:
     if o.name[0:4] == "Cube":
      myfile.write("    -"+"\n")
      loc = o.matrixWorld.translationPart()
      myfile.write("      posx : " + str(loc[0])+"\n")
      myfile.write("      posy : " + str(loc[1])+"\n")
      myfile.write("      posz : " + str(loc[2])+"\n")
      myfile.write("      sizex: " + str(o.SizeX*2)+"\n")
      myfile.write("      sizey: " + str(o.SizeY*2)+"\n")
      myfile.write("      sizez: " + str(o.SizeZ*2)+"\n")
      q = o.getMatrix().toQuat()
      myfile.write("      qx: " + str(q.x)+"\n")
      myfile.write("      qy: " + str(q.y)+"\n")
      myfile.write("      qz: " + str(q.z)+"\n")
      myfile.write("      qw: " + str(q.w)+"\n")
    
      mat = o.getData().getMaterials()
      if len(mat) > 0:
        rgb = mat[0].getRGBCol()
    
        myfile.write("      colr : " + str(rgb[0])+"\n")
        myfile.write("      colg : " + str(rgb[1])+"\n")
        myfile.write("      colb : " + str(rgb[2])+"\n")
    
    myfile.write("  objects:"+"\n")
    for o in objects:
     if o.name[0:4] == "Cone":
      myfile.write("    -"+"\n")
      myfile.write("      posx : " + str(o.LocX)+"\n")
      myfile.write("      posy : " + str(o.LocY)+"\n")
      myfile.write("      posz : " + str(o.LocZ)+"\n")
      myfile.write("      type : cone"+"\n")
    
    def outCheckpoint(o, d):
      space = "  " * d
    
      myfile.write(space + "  -"+"\n")
      loc = o.matrixWorld.translationPart()
      myfile.write(space + "    posx : " + str(loc[0])+"\n")
      myfile.write(space + "    posy : " + str(loc[1])+"\n")
      myfile.write(space + "    posz : " + str(loc[2])+"\n")
    
      prntPrevious = 0
       
      for c in objects:
        if c.name[0:8] == "Cylinder" and c.getParent() == o:
          if not prntPrevious:
            prntPrevious = 1
            myfile.write(space + "    previous : "+"\n")
          outCheckpoint(c, d+2)
    
    
    myfile.write("  checkpoints:"+"\n")
    cp = 0
    found = 1
    start = 1
    
    while (found == 1 or start == 1) and cp < 100:
      found = 0
      for o in objects:
        if o.name[0:6] == "Sphere":
          if int(o.name[7:]) == cp:
             start = 0
             outCheckpoint(o, 2)
             cp = cp+1
             found = 1
             myfile.write("        size: " + str(o.SizeX)+"\n")
      if not found:
        cp = cp+1
        
    myfile.close()


objects = Blender.Object.GetSelected()
Window.FileSelector(my_callback, "Save as")